signature TMINML =
sig

  datatype typ =
      INT
    | BOOL
    | TAGGED
    | ARROW of typ * typ

  datatype primop = Equal | Plus | Minus | Times | Negate

  datatype exp =
      Int of int

    | Bool of bool

    (* if ec then et else ef fi 
       If(ec, et, ef) *)
    | If of exp * exp * exp

    | Primop of primop * exp list

  (* fun f (x : td) : tr is e end
     Fun(f, x, td, tr, e) *)
    | Fun of string * string * typ * typ * exp

  (* e1 e2
     Apply(e1, e2) *)
    | Apply of exp * exp

    | Var of string

    | TagInt of exp | TagBool of exp | TagFun of exp
    | AsInt of exp | AsBool of exp | AsFun of exp

  (* given a primop, get its argument and result types *)
  val typeOfPrimop : primop -> typ list * typ

  (* given a primop and some arguments, try to apply it *)
  val evalPrimop : primop * exp list -> exp option

end
