
structure Top :> TOP =
struct

fun do_one ( e : EDMinML.exp ) =
  (case EDTyping.classOpt e of
     NONE => (print "ERROR: Expression is ill-formed.\n")
   | SOME _ =>
       let val (e',tau) = Translate.translate e
       in
	 case TTyping.typeOpt e' of
	   SOME tau' =>
	     if tau = tau' then
	       (print (TPrint.expToString e');
		print "\n : ";
		print (TPrint.typToString tau);
		print "\n")
	     else
	       (print "ERROR: Translated expression does not have the type it claims!\n";
		print "Translated as:\n";
		print (TPrint.expToString e');
		print "\nTranslation says type is ";
		print (TPrint.typToString tau);
		print "\nbut actual type is ";
		print (TPrint.typToString tau');
		print "\n")
	 | NONE =>
	       (print "ERROR: Translates as an ill-typed expression!\n";
		print "Translated as:\n";
		print (TPrint.expToString e');
		print "\nTranslation says type is ";
		print (TPrint.typToString tau);
		print "\nbut this is actually ill-typed.")
       end)

fun loop () =
    Stream.app do_one (EDParse.parse (EDLexer.lex (Input.promptkeybd "MinML> ")))
  
fun file f =
    Stream.app do_one (EDParse.parse (EDLexer.lex (Input.readfile f)))
    
end