structure TPrint :> TPRINT =
struct

    structure M = TMinML

    exception Unimplemented (* XXXXXXXXXXXXXXXXXXXXXXX *)

    fun po M.Equal = "="
      | po M.Plus = "+"
      | po M.Minus = "-"
      | po M.Times = "*"
      | po M.Negate = "~"

    fun typToString M.INT = "int"
      | typToString M.BOOL = "bool"
      | typToString M.TAGGED = "tagged"
      | typToString (M.ARROW(d, r)) = "-> " ^ typToString d ^ " " ^ typToString r

    and expToString (M.Int i) = Int.toString i
      | expToString (M.Bool true) = "true"
      | expToString (M.Bool false) = "false"
      | expToString (M.If (ec, et, ef)) = "if " ^ expToString ec ^ " then " ^
                                          expToString et ^ " else " ^ expToString ef ^
                                          " fi"
      | expToString (M.Primop (p, nil)) = "(bad primop)"
      | expToString (M.Primop (p, el)) = po p ^ "(" ^ 
                                          foldl (fn (a, b) => b ^ ", " ^ (expToString a)) 
                                              (expToString (hd el)) (tl el) ^ ")"
      | expToString (M.Fun (f, x, d, r, e)) =
                                          "fun " ^ f ^ "(" ^ x ^ " : " ^ typToString d ^ ") : " ^
                                          typToString r ^ " is " ^ expToString e ^ " end"
      | expToString (M.Apply (f, e)) = "(" ^ expToString f ^ " " ^ expToString e ^ ")"
      | expToString (M.Var v) = v
      | expToString (M.TagInt e) = "tag_int (" ^ expToString e ^ ")"
      | expToString (M.TagBool e) = "tag_bool (" ^ expToString e ^ ")"
      | expToString (M.TagFun e) = "tag_fun (" ^ expToString e ^ ")"
      | expToString (M.AsInt e) = "as_int (" ^ expToString e ^ ")"
      | expToString (M.AsBool e) = "as_bool (" ^ expToString e ^ ")"
      | expToString (M.AsFun e) = "as_fun (" ^ expToString e ^ ")"

end
